ACIACR	EQU	????
ACIAST	EQU	ACIACR
ACIATX	EQU	????
ACIARX	EQU	ACIATX
ACIASET	EQU	????

	ORG	$9000
MAIN	JSR	INITACIA
MAINLP	LDA	#'>'
	JSR	TXDATA
	JSR	RXDATA
	JSR	TXDATA
	CMPA	#'L'
	BNE	NOTL
	JSR	LCMD
	BRA	MAINLP
NOTL	CMPA	#'P'
	BNE	NOTP
	JSR	PCMD
	BRA	MAINLP
NOTP	CMPA	#'B'
	BNE	NOTB
	JSR	BCMD
	BRA	MAINLP
NOTB	CMPA	#'T'
	BNE	NOTT
	JSR	TCMD
	BRA	MAINLP
NOTT	CMPA	#'E'
	BNE	NOTE
	JSR	ECMD
	BRA	MAINLP
NOTE	CMPA	#'Z'
	BNE	NOTZ
	JSR	ZCMD
NOTZ	BRA	MAINLP

***************************************************
*                                                 *
*   MODULE      : Initialise ACIA                 *
*   PURPOSE     : To set the ACIA as rEQUired     *
*   CALLED BY   : RXDATA                          *
*   CALLS       : Nil                             *
*   REG'S USED  : B                               *
*   VALIDATION  : Check ACIA function after       *
*                                                 *
***************************************************
INITACIA    LDB     #$03        * reset control word
            STB     ACIACR      * into control reg
            LDB     #ACIASET    * selected control word
            STB     ACIACR      * into control reg
            LDB     ACIARX      * clear status flags
            RTS                 *

***************************************************
*                                                 *
*   MODULE      : Transmit Data ACIA              *
*   PURPOSE     : Transmit a byte to Terminal     *
*   CALLED BY   :                                 *
*   CALLS       : Nil                             *
*   REG'S USED  : A, B                            *
*   VALIDATION  : A is ASCII to be sent,          *
*                 repeat call, see terminal       *
***************************************************
TXDATA      LDB     ACIAST      * test to see if the ACIA
            BITB    #%00000010  * transmit data reg is empty
            BEQ     TXDATA      * if not test again
            STA     ACIATX      * transmit data to terminal
            RTS                 *

***************************************************
*                                                 *
*   MODULE      : Receive Data ACIA               *
*   PURPOSE     : Receive byte from Terminal      *
*   CALLED BY   :                                 *
*   CALLS       : INITACIA on an error            *
*   REG'S USED  : A, B                            *
*   VALIDATION  : Call, type input at terminal    *
*                 ASCII returned in A             *
***************************************************
RXDATA      LDB     ACIAST      * test to see if ACIA
            BITB    #%00000001  * receive data reg is full
            BEQ     RXDATA      * if not then test again
            BITB    #%01110000  * was there an error in Rx
            BNE     ERROR       * if yes correct error
            LDA     ACIARX      * load ASCII from terminal
            RTS                 * return ASCII in A
ERROR       BSR     INITACIA    * on error reset ACIA
            BRA     RXDATA      * wait for new ASCII data

LCMD	RTS
PCMD	RTS
BCMD	RTS
TCMD	RTS
ECMD	RTS
ZCMD	RTS


