LCDCTRL EQU	$000C
LCDDATA EQU	$000D
EOT     EQU	$04

        ORG     $8000
STRING  FCC     "HELLO WORLD"
        FCB     EOT

        ORG     $9000
MAIN    JSR     LCDINIT
        LDX     #STRING
        JSR     LCDSTR
        JSR     WAIT
        JSR     WAIT
        JSR     WAIT
        JSR     LCDCLR
        LDA     #$40
        JSR     LCDPOS
        LDX     #STRING
        JSR     LCDSTR
HERE    BRA     HERE

LCDOUT  JSR     BUSY
        STA     LCDDATA
        RTS

LCDSTR  LDA     0,X+
        CMPA    #EOT
        BEQ     LCDEXIT
        JSR     LCDOUT
        BRA     LCDSTR
LCDEXIT RTS

LCDCLR  JSR     BUSY
        LDA     #%00000001
        STA     LCDCTRL
        RTS

LCDPOS  JSR     BUSY
        ORA     #%10000000
        STA     LCDCTRL
        RTS

*********************************************************
*       SUBROUTINE     LCDINIT.                         *
*       PURPOSE -      INITIALISES THE LCD DISPLAY.     *
*       CALLED BY -                                     *
*       CALLS -        WAIT,BUSY.                       *
*********************************************************

LCDINIT LDA     #$30
        STA     $000C   1ST FUNCTION SET
        JSR     WAIT
        LDA     #$30
        STA     $000C   2ND FUNCTION SET
        JSR     WAIT
        LDA     #$38
        STA     $000C   3RD FUNCTION SET
        JSR     BUSY    WAIT UNTIL NOT BUSY
        LDA     #$01    CLEAR DISPLAY
        STA     $000C
        JSR     BUSY    WAIT UNTIL NOT BUSY
        LDA     #$06    SET DIRECTION OF CURSOR
        STA     $000C
        JSR     BUSY    WAIT UNTIL NOT BUSY
        LDA     #$0E    SET DISPLAY & CURSOR ON
        STA     $000C
        JSR     BUSY    WAIT UNTIL NOT BUSY
        RTS

*********************************************************
*       SUBROUTINE     BUSY.                            *
*       PURPOSE -      WAITS FOR BUSY FLAG ON LCD DRIVER*
*                      TO CLEAR.                        *
*                                                       *
*       CALLED BY -    LCD.                             *
*       CALLS -        NIL                              *
*********************************************************

BUSY    TST     $000C   GET BUSY FLAG
        BMI     BUSY    CHECK BUSY FLAG
        RTS

*********************************************************
*       SUBROUTINE     WAIT.                            *
*       PURPOSE -      PROVIDES DELAY FOR LCD           *
*                      INITIALIZATION.                  *
*       CALLED BY -    LCD.                             *
*       CALLS -        NIL.                             *
*********************************************************

WAIT    LDB     #$FF    LOAD ACCB WITH COUNT
L1      DECB
        LDA     #$FF    LOAD ACCA WITH COUNT
L2      DECA
        BNE     L2      END OF ACCA COUNT ?
        TSTB            END OF ACCB COUNT ?
        BNE     L1      NO THEN BRANCH
        RTS


